package cn.iocoder.yudao.module.pms.dal.mysql;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.mapper.BaseMapperX;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.module.pms.controller.admin.vo.IotProductClassifyListReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.vo.IotProductClassifyPageReqVO;
import cn.iocoder.yudao.module.pms.dal.dataobject.IotProductClassifyDO;
import org.apache.ibatis.annotations.Mapper;

import java.util.Collection;
import java.util.List;
import java.util.Set;

/**
 * 设备分类 Mapper
 *
 * @author 芋道源码
 */
@Mapper
public interface IotProductClassifyMapper extends BaseMapperX<IotProductClassifyDO> {
    default List<IotProductClassifyDO> selectListByParentId(Collection<Long> parentIds) {
        return selectList(IotProductClassifyDO::getParentId, parentIds);
    }
    default IotProductClassifyDO selectByParentIdAndName(Long parentId, String name) {
        return selectOne(IotProductClassifyDO::getParentId, parentId, IotProductClassifyDO::getName, name);
    }
    default List<IotProductClassifyDO> selectByName(Set<String> ids) {
        return selectList(IotProductClassifyDO::getName, ids);
    }
    default List<IotProductClassifyDO> selectList(IotProductClassifyListReqVO reqVO) {
        return selectList(new LambdaQueryWrapperX<IotProductClassifyDO>()
                .likeIfPresent(IotProductClassifyDO::getName, reqVO.getName())
                .likeIfPresent(IotProductClassifyDO::getRemark, reqVO.getRemark())
                .eqIfPresent(IotProductClassifyDO::getStatus, reqVO.getStatus()));
    }
    default Long selectCountByParentId(Long parentId) {
        return selectCount(IotProductClassifyDO::getParentId, parentId);
    }
    default PageResult<IotProductClassifyDO> selectPage(IotProductClassifyPageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<IotProductClassifyDO>()
                .eqIfPresent(IotProductClassifyDO::getParentId, reqVO.getParentId())
                .likeIfPresent(IotProductClassifyDO::getName, reqVO.getName())
                .eqIfPresent(IotProductClassifyDO::getCode, reqVO.getCode())
                .eqIfPresent(IotProductClassifyDO::getSort, reqVO.getSort())
                .eqIfPresent(IotProductClassifyDO::getStatus, reqVO.getStatus())
                .eqIfPresent(IotProductClassifyDO::getRemark, reqVO.getRemark())
                .betweenIfPresent(IotProductClassifyDO::getCreateTime, reqVO.getCreateTime())
                .orderByDesc(IotProductClassifyDO::getId));
    }

}
